#!ruby -Ks
# -*- mode: ruby; encoding: sjis -*-
# Last updated: <2014/06/07 15:38:11 +0900>
#
# ShadergăX^XN[̃eXg
# VAǁAX^[XN[ۂ̏
# 摜ǂݍŕ\

require 'dxruby'

class BgRasterScroll3

  attr_accessor :gridsize
  attr_accessor :imgs
  attr_accessor :shaders

  # RXgN^
  #
  # @param [Number] gridsize 1}X̃hbgTCY
  # @param [Array] imgs VAǁAImageIuWFNgzɓēn
  #
  def initialize(gridsize, imgs)
    hlsl = <<EOS
  float2 size;
  float d;
  float dd;
  texture tex0;

  sampler Samp0 = sampler_state
  {
    Texture =<tex0>;

    // Ɖʂ`` (L֥M)
    // MinFilter = LINEAR;
    // MagFilter = LINEAR;
    // MipFilter = LINEAR;

    // Ȃ``Ȃ
    MinFilter = POINT;
    MagFilter = POINT;
    MipFilter = NONE;

    AddressU = WRAP;
    AddressV = WRAP;
  };

  struct PixelIn
  {
    float2 UV : TEXCOORD0;
  };

  struct PixelOut
  {
    float4 Color : COLOR0;
  };

  PixelOut PS1(PixelIn input)
  {
    PixelOut output;
    input.UV.x = input.UV.x + ((d + (d * input.UV.y * dd)) / size.x);
    output.Color = tex2D( Samp0, input.UV );
    return output;
  }

  PixelOut PS2(PixelIn input)
  {
    PixelOut output;
    input.UV.x = input.UV.x + ((d + (d * (1.0 - input.UV.y) * dd)) / size.x);
    output.Color = tex2D( Samp0, input.UV );
    return output;
  }

  PixelOut PS3(PixelIn input)
  {
    PixelOut output;
    input.UV.x = input.UV.x + d / size.x;
    output.Color = tex2D( Samp0, input.UV );
    return output;
  }

//   float4 PS(float2 input : TEXCOORD0) : COLOR0
//   {
//     float4 output;
//     // input.x -= ((d / size.x) + ((d / size.x) * input.y * dd));
//     input.x = input.x - ((d + (d * input.y * dd)) / size.x);
//     output = tex2D( Samp0, input);
//     return output;
//   }

  technique FloorScroll
  {
    pass P0
    {
      PixelShader = compile ps_2_0 PS1();
    }
  }
  technique CeilingScroll
  {
    pass P0
    {
      PixelShader = compile ps_2_0 PS2();
    }
  }
  technique WallScroll
  {
    pass P0
    {
      PixelShader = compile ps_2_0 PS3();
    }
  }
EOS

    core = Shader::Core.new(hlsl, {:size=>:float, :d=>:float, :dd=>:float})
    self.shaders = []
    self.imgs = []
    self.gridsize = gridsize

    shader_names = [
      ["CeilingScroll", 1.0],
      ["WallScroll", 1.0],
      ["FloorScroll", 1.0]
    ]

    shader_names.each_with_index do |dt, i|
      sname, dd = dt
      img = imgs[i]
      self.imgs.push(img)
      shr = Shader.new(core, sname)
      shr.size = [img.width, img.height]
      shr.d = 0 # XN[
      shr.dd = dd # ӂƉӂŁAxɉhbg邩
      self.shaders.push(shr)
    end
  end

  # XN[ʂXV
  #
  # @param [Number] d XN[
  #
  def update(d)
    d = (d % self.gridsize)
    self.shaders.each do |shr|
      shr.d = d
    end
  end

  # `
  #
  # @param [Number] bx `ʒu x
  # @param [Number] by `ʒu y
  #
  def draw(bx, by)
    x, y = bx - self.gridsize * 2, by
    3.times do |i|
      Window.drawShader(x, y, self.imgs[i], self.shaders[i])
      y += self.imgs[i].height
    end
  end

end


if __FILE__ == $0
  # ----------------------------------------
  # mF

  imgs = []

  # 摜t@Cꗗɏ]ĉ摜[h
  [
    "bg_ras_a.png", # V
    "bg_ras_b.png", # 
    "bg_ras_c.png" # 
  ].each {|fn| imgs.push(Image.load(fn)) }

  # X^[XN[pIuWFNg𔭐
  ras = BgRasterScroll3.new(64, imgs)

  # XvCg𔭐
  pole = Image.load("pole.png")
  sprs = []
  4.times do |i|
    spr = Sprite.new(i * (96 * 2) + 72, 480 - (160 /2) - 128 + 8, pole)
    sprs.push(spr)
  end

  font = Font.new(14)
  x = 0
  Window.loop do
    break if Input.keyPush?(K_ESCAPE)

    # }EXʒuɉăXN[ʂω
    dx = ((Window.width / 2) -  Input.mousePosX).to_f / Window.width * 32
    x -= dx
    ras.update(x) # XN[ʂw

    ras.draw(0, 0) # `

    # `
    tdx = dx + dx * 0.5
    sprs.each do |spr|
      spr.x += tdx
      spr.x += Window.width + 128 if dx < 0 and spr.x + 64 < 0
      spr.x -= (Window.width + 128) if dx > 0 and spr.x > Window.width
    end

    Sprite.update(sprs)
    Sprite.draw(sprs)

    Window.drawFont(4, 4, "dx = #{dx} , x = #{x}", font)
  end
end
